/*
 *
 * Copyright (c) 2011 - Network Appliance Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		     
 */

#include <linux/types.h>
#include <stdarg.h>
#include <linux/kernel.h>
#include <linux/delay.h>

#define VSC452_GPIO_BASE_OFFSET 0xB0200A00
#define VSC452_GPBC(pin) (VSC452_GPIO_BASE_OFFSET + (pin * 0x4))

void tap_gpio_set_value(int pin, int value)
{
	value = value ? 0x1 : 0x0;
	*((volatile uint32_t*)VSC452_GPBC(pin)) = value;
}

int tap_gpio_get_value(int pin)
{
	int value;
	value = (*(volatile uint32_t*)VSC452_GPBC(pin)) & 0x1;
	return value;
}

void tap_gpio_direction_output(int pin, int value)
{
	/*
         * Bit 0 is value, Bit 1 is direction: 0 for output, 1 for input
         */
	value = value ? 0x1 : 0x0;
	*((volatile uint32_t*)VSC452_GPBC(pin)) = value;
}

void tap_gpio_direction_input(int pin)
{
	*((volatile uint32_t*)VSC452_GPBC(pin)) = 0x2;	
}

